'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./style/index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Badge = (_temp = _class = function (_Component) {
    _inherits(Badge, _Component);

    function Badge() {
        _classCallCheck(this, Badge);

        return _possibleConstructorReturn(this, (Badge.__proto__ || Object.getPrototypeOf(Badge)).apply(this, arguments));
    }

    _createClass(Badge, [{
        key: 'render',
        value: function render() {
            var _classNames, _classNames2;

            var _props = this.props,
                className = _props.className,
                prefixCls = _props.prefixCls,
                children = _props.children,
                text = _props.text,
                size = _props.size,
                overflowCount = _props.overflowCount,
                dot = _props.dot,
                corner = _props.corner,
                hot = _props.hot,
                restProps = _objectWithoutProperties(_props, ['className', 'prefixCls', 'children', 'text', 'size', 'overflowCount', 'dot', 'corner', 'hot']);

            text = typeof text === 'number' && text > overflowCount ? overflowCount + '+' : text;

            //dot mode don't need text
            if (dot) {
                text = "";
            }

            // null undefined "" "0" 0
            var hidden = (!text || text === '0') && !dot;

            var scrollNumberCls = (0, _classnames2.default)((_classNames = {}, _defineProperty(_classNames, prefixCls + '-dot', dot), _defineProperty(_classNames, prefixCls + '-dot-large', dot && size === 'large'), _defineProperty(_classNames, prefixCls + '-text', !dot && !corner), _defineProperty(_classNames, prefixCls + '-corner', corner), _defineProperty(_classNames, prefixCls + '-corner-large', corner && size === 'large'), _classNames));

            var badgeCls = (0, _classnames2.default)((_classNames2 = {}, _defineProperty(_classNames2, className, !!className), _defineProperty(_classNames2, prefixCls, true), _defineProperty(_classNames2, prefixCls + '-not-a-wrapper', !children), _defineProperty(_classNames2, prefixCls + '-corner-wrapper', corner), _defineProperty(_classNames2, prefixCls + '-hot', !!hot), _defineProperty(_classNames2, prefixCls + '-corner-wrapper-large', corner && size === 'large'), _classNames2));

            return _react2.default.createElement(
                'span',
                { className: badgeCls },
                children,
                (text || dot) && _react2.default.createElement(
                    'sup',
                    _extends({ className: scrollNumberCls }, restProps),
                    text
                )
            );
        }
    }]);

    return Badge;
}(_react.Component), _class.defaultProps = {
    prefixCls: 'badge',
    size: 'small',
    overflowCount: 99,
    text: null,
    dot: false,
    corner: false
}, _temp);
exports.default = Badge;