'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _AppIcon = require('./../AppIcon');

var _AppIcon2 = _interopRequireDefault(_AppIcon);

var _rcTouchable = require('rc-touchable');

var _rcTouchable2 = _interopRequireDefault(_rcTouchable);

require('./style/index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var rxTwoCNChar = /^[\u4e00-\u9fa5]{2}$/;
var isTwoCNChar = rxTwoCNChar.test.bind(rxTwoCNChar);

function isString(str) {
    return typeof str === 'string';
}

// Insert one space between two chinese characters automatically.
function insertSpace(child) {
    if (isString(child.type) && isTwoCNChar(child.props.children)) {
        return _react2.default.cloneElement(child, {}, child.props.children.split('').join(' '));
    }
    if (isString(child)) {
        if (isTwoCNChar(child)) {
            child = child.split('').join(' ');
        }

        return _react2.default.createElement(
            'span',
            null,
            child
        );
    }

    return child;
}

var Button = (_temp = _class = function (_Component) {
    _inherits(Button, _Component);

    function Button() {
        _classCallCheck(this, Button);

        return _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).apply(this, arguments));
    }

    _createClass(Button, [{
        key: 'render',
        value: function render() {
            var _wrapCls;

            var _props = this.props,
                children = _props.children,
                className = _props.className,
                prefixCls = _props.prefixCls,
                type = _props.type,
                size = _props.size,
                inline = _props.inline,
                across = _props.across,
                rectangular = _props.rectangular,
                disabled = _props.disabled,
                icon = _props.icon,
                loading = _props.loading,
                activeStyle = _props.activeStyle,
                onClick = _props.onClick,
                restProps = _objectWithoutProperties(_props, ['children', 'className', 'prefixCls', 'type', 'size', 'inline', 'across', 'rectangular', 'disabled', 'icon', 'loading', 'activeStyle', 'onClick']);

            var wrapCls = (_wrapCls = {}, _defineProperty(_wrapCls, className, !!className), _defineProperty(_wrapCls, prefixCls, true), _defineProperty(_wrapCls, prefixCls + '-primary', type === 'primary'), _defineProperty(_wrapCls, prefixCls + '-ghost', type === 'ghost'), _defineProperty(_wrapCls, prefixCls + '-warning', type === 'warning'), _defineProperty(_wrapCls, prefixCls + '-small', size === 'small'), _defineProperty(_wrapCls, prefixCls + '-middle', size === 'middle'), _defineProperty(_wrapCls, prefixCls + '-inline', inline), _defineProperty(_wrapCls, prefixCls + '-across', across), _defineProperty(_wrapCls, prefixCls + '-rectangular', rectangular), _defineProperty(_wrapCls, prefixCls + '-disabled', disabled), _defineProperty(_wrapCls, prefixCls + '-loading', loading), _wrapCls);

            var iconType = loading ? 'jiazai2' : icon;
            var kids = _react2.default.Children.map(children, insertSpace);

            if (iconType) {
                wrapCls[prefixCls + '-icon'] = true;
            }

            //use div, button native is buggy @yiminghe
            return _react2.default.createElement(
                _rcTouchable2.default,
                {
                    activeClassName: activeStyle ? prefixCls + '-active' : undefined,
                    disabled: disabled,
                    activeStyle: activeStyle
                },
                _react2.default.createElement(
                    'a',
                    _extends({
                        role: 'button',
                        className: (0, _classnames2.default)(wrapCls)
                    }, restProps, {
                        onClick: disabled ? undefined : onClick
                    }),
                    iconType ? _react2.default.createElement(_AppIcon2.default, { type: iconType }) : null,
                    kids
                )
            );
        }
    }]);

    return Button;
}(_react.Component), _class.defaultProps = {
    prefixCls: 'button',
    size: 'large',
    inline: false,
    across: false,
    disabled: false,
    loading: false,
    activeStyle: {}
}, _temp);
exports.default = Button;