'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _index = require('../Flex/index');

var _index2 = _interopRequireDefault(_index);

var _index3 = require('../Carousel/index');

var _index4 = _interopRequireDefault(_index3);

require('./style/index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Grid = (_temp = _class = function (_Component) {
    _inherits(Grid, _Component);

    function Grid() {
        _classCallCheck(this, Grid);

        return _possibleConstructorReturn(this, (Grid.__proto__ || Object.getPrototypeOf(Grid)).apply(this, arguments));
    }

    _createClass(Grid, [{
        key: 'render',
        value: function render() {
            var _this2 = this,
                _classNames;

            var _props = this.props,
                prefixCls = _props.prefixCls,
                className = _props.className,
                data = _props.data,
                hasLine = _props.hasLine,
                columnNum = _props.columnNum,
                isCarousel = _props.isCarousel,
                carouselMaxRow = _props.carouselMaxRow,
                _onClick = _props.onClick;


            var dataLength = data && data.length || 0;
            var rowCount = Math.ceil(dataLength / columnNum);
            var rowWidth = 100 / columnNum + '%';
            var colStyle = {
                width: rowWidth
            };

            var renderItem = function renderItem(dataItem, index) {
                return _react2.default.createElement(
                    'div',
                    {
                        className: prefixCls + '-item-content'
                    },
                    _this2.props.renderItem ? _this2.props.renderItem(dataItem, index) : _react2.default.createElement(
                        'div',
                        { className: prefixCls + '-item-inner-content column-num-' + columnNum },
                        _react2.default.isValidElement(dataItem.icon) ? dataItem.icon : _react2.default.createElement('img', { className: prefixCls + '-icon', src: dataItem.icon }),
                        _react2.default.createElement(
                            'div',
                            { className: prefixCls + '-text' },
                            dataItem.text
                        )
                    )
                );
            };

            var rowsArr = [];

            for (var i = 0; i < rowCount; i++) {
                var rowArr = [];

                var _loop = function _loop(j) {
                    var dataIndex = i * columnNum + j;
                    if (dataIndex < dataLength) {
                        var el = data && data[dataIndex];
                        rowArr.push(_react2.default.createElement(
                            _index2.default.Item,
                            {
                                key: 'griditem-' + dataIndex,
                                className: prefixCls + '-item',
                                onClick: function onClick() {
                                    return _onClick(el, dataIndex);
                                },
                                style: colStyle
                            },
                            el && renderItem(el, dataIndex)
                        ));
                    } else {
                        rowArr.push(_react2.default.createElement(_index2.default.Item, {
                            key: 'griditem-' + dataIndex,
                            style: colStyle
                        }));
                    }
                };

                for (var j = 0; j < columnNum; j++) {
                    _loop(j);
                }
                rowsArr.push(_react2.default.createElement(
                    _index2.default,
                    { justify: 'center', align: 'stretch', key: 'gridline-' + i },
                    rowArr
                ));
            }

            var pageCount = Math.ceil(rowCount / carouselMaxRow);
            var pagesArr = [];
            if (isCarousel && pageCount > 1) {
                for (var pageIndex = 0; pageIndex < pageCount; pageIndex++) {
                    var pageRows = [];
                    for (var ii = 0; ii < carouselMaxRow; ii++) {
                        var rowIndex = pageIndex * carouselMaxRow + ii;
                        if (rowIndex < rowCount) {
                            pageRows.push(rowsArr[rowIndex]);
                        } else {
                            // 空节点为了确保末尾页的最后未到底的行有底线(样式中last-child会没线)
                            pageRows.push(_react2.default.createElement('div', { key: 'gridline-' + rowIndex }));
                        }
                    }
                    pagesArr.push(_react2.default.createElement(
                        'div',
                        { key: 'pageitem-' + pageIndex,
                            className: prefixCls + '-carousel-page' },
                        pageRows
                    ));
                }
            }

            return _react2.default.createElement(
                'div',
                {
                    className: (0, _classnames2.default)((_classNames = {}, _defineProperty(_classNames, prefixCls, true), _defineProperty(_classNames, prefixCls + '-line', hasLine), _defineProperty(_classNames, className, !!className), _classNames))
                },
                isCarousel && pageCount > 1 ? _react2.default.createElement(
                    _index4.default,
                    { initialSlideWidth: this.clientWidth },
                    pagesArr
                ) : rowsArr
            );
        }
    }]);

    return Grid;
}(_react.Component), _class.defaultProps = {
    data: [],
    hasLine: true,
    isCarousel: false,
    columnNum: 4,
    carouselMaxRow: 2,
    prefixCls: 'grid',
    onClick: function onClick() {}
}, _temp);
exports.default = Grid;