'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = exports.Brief = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _rcTouchable = require('rc-touchable');

var _rcTouchable2 = _interopRequireDefault(_rcTouchable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Brief = exports.Brief = function (_Component) {
    _inherits(Brief, _Component);

    function Brief() {
        _classCallCheck(this, Brief);

        return _possibleConstructorReturn(this, (Brief.__proto__ || Object.getPrototypeOf(Brief)).apply(this, arguments));
    }

    _createClass(Brief, [{
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                'div',
                { className: 'list-brief', style: this.props.style },
                this.props.children
            );
        }
    }]);

    return Brief;
}(_react.Component);

;

var ListItem = (_temp = _class = function (_Component2) {
    _inherits(ListItem, _Component2);

    function ListItem() {
        _classCallCheck(this, ListItem);

        return _possibleConstructorReturn(this, (ListItem.__proto__ || Object.getPrototypeOf(ListItem)).apply(this, arguments));
    }

    _createClass(ListItem, [{
        key: 'render',
        value: function render() {
            var _wrapCls, _classNames, _classNames2;

            var _props = this.props,
                prefixCls = _props.prefixCls,
                className = _props.className,
                activeStyle = _props.activeStyle,
                error = _props.error,
                align = _props.align,
                wrap = _props.wrap,
                disabled = _props.disabled,
                children = _props.children,
                multipleLine = _props.multipleLine,
                thumb = _props.thumb,
                extra = _props.extra,
                arrow = _props.arrow,
                restProps = _objectWithoutProperties(_props, ['prefixCls', 'className', 'activeStyle', 'error', 'align', 'wrap', 'disabled', 'children', 'multipleLine', 'thumb', 'extra', 'arrow']);

            var wrapCls = (_wrapCls = {}, _defineProperty(_wrapCls, className, className), _defineProperty(_wrapCls, prefixCls + '-item', true), _defineProperty(_wrapCls, prefixCls + '-item-disabled', disabled), _defineProperty(_wrapCls, prefixCls + '-item-error', error), _defineProperty(_wrapCls, prefixCls + '-item-top', align === 'top'), _defineProperty(_wrapCls, prefixCls + '-item-middle', align === 'middle'), _defineProperty(_wrapCls, prefixCls + '-item-bottom', align === 'bottom'), _wrapCls);

            var lineCls = (0, _classnames2.default)((_classNames = {}, _defineProperty(_classNames, prefixCls + '-line', true), _defineProperty(_classNames, prefixCls + '-line-multiple', multipleLine), _defineProperty(_classNames, prefixCls + '-line-wrap', wrap), _classNames));

            var arrowCls = (0, _classnames2.default)((_classNames2 = {}, _defineProperty(_classNames2, prefixCls + '-arrow', true), _defineProperty(_classNames2, prefixCls + '-arrow-horizontal', arrow === 'horizontal'), _defineProperty(_classNames2, prefixCls + '-arrow-vertical', arrow === 'down' || arrow === 'up'), _defineProperty(_classNames2, prefixCls + '-arrow-vertical-up', arrow === 'up'), _classNames2));

            var content = _react2.default.createElement(
                'div',
                _extends({}, restProps, { className: (0, _classnames2.default)(wrapCls) }),
                thumb ? _react2.default.createElement(
                    'div',
                    { className: prefixCls + '-thumb' },
                    typeof thumb === 'string' ? _react2.default.createElement('img', { src: thumb }) : thumb
                ) : null,
                _react2.default.createElement(
                    'div',
                    { className: lineCls },
                    children !== undefined && _react2.default.createElement(
                        'div',
                        { className: prefixCls + '-content' },
                        children
                    ),
                    extra !== undefined && _react2.default.createElement(
                        'div',
                        { className: prefixCls + '-extra' },
                        extra
                    ),
                    arrow && _react2.default.createElement('div', { className: arrowCls })
                )
            );

            return _react2.default.createElement(
                _rcTouchable2.default,
                { disabled: disabled || !restProps.onClick,
                    activeStyle: activeStyle,
                    activeClassName: prefixCls + '-item-active' },
                content
            );
        }
    }]);

    return ListItem;
}(_react.Component), _class.defaultProps = {
    prefixCls: 'list',
    align: 'middle',
    error: false,
    multipleLine: false,
    wrap: false
}, _class.Brief = Brief, _temp);
exports.default = ListItem;
;