'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.getDefaultProps = getDefaultProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Popup = require('rmc-cascader/lib/Popup');

var _Popup2 = _interopRequireDefault(_Popup);

var _Cascader = require('rmc-cascader/lib/Cascader');

var _Cascader2 = _interopRequireDefault(_Cascader);

var _MultiPicker = require('rmc-picker/lib/MultiPicker');

var _MultiPicker2 = _interopRequireDefault(_MultiPicker);

var _Picker = require('rmc-picker/lib/Picker');

var _Picker2 = _interopRequireDefault(_Picker);

var _arrayTreeFilter = require('array-tree-filter');

var _arrayTreeFilter2 = _interopRequireDefault(_arrayTreeFilter);

var _popupProps = require('./popupProps');

var _popupProps2 = _interopRequireDefault(_popupProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by seven on 2017/8/3.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


function getDefaultProps() {
    var defaultFormat = function defaultFormat(values) {
        return values.join(',');
    };
    return {
        triggerType: 'onClick',
        prefixCls: 'picker',
        pickerPrefixCls: 'picker-col',
        popupPrefixCls: 'picker-popup',
        format: defaultFormat,
        cols: 3,
        cascade: true,
        extra: '请选择',
        okText: '确定',
        dismissText: '取消',
        title: ''
    };
}

var AbstractPicker = function (_React$Component) {
    _inherits(AbstractPicker, _React$Component);

    function AbstractPicker() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, AbstractPicker);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = AbstractPicker.__proto__ || Object.getPrototypeOf(AbstractPicker)).call.apply(_ref, [this].concat(args))), _this), _this.popupProps = _popupProps2.default, _this.getSel = function () {
            var value = _this.props.value || [];
            var treeChildren = void 0;
            if (_this.props.cascade) {
                treeChildren = (0, _arrayTreeFilter2.default)(_this.props.data, function (c, level) {
                    return c.value === value[level];
                });
            } else {
                treeChildren = value.map(function (v, i) {
                    return _this.props.data[i].filter(function (d) {
                        return d.value === v;
                    })[0];
                });
            }
            return _this.props.format && _this.props.format(treeChildren.map(function (v) {
                return v.label;
            }));
        }, _this.getPickerCol = function () {
            var _this$props = _this.props,
                data = _this$props.data,
                pickerPrefixCls = _this$props.pickerPrefixCls;


            return data.map(function (col, index) {
                return _react2.default.createElement(
                    _Picker2.default,
                    { key: index, prefixCls: pickerPrefixCls },
                    col.map(function (item) {
                        return _react2.default.createElement(
                            _Picker2.default.Item,
                            { key: item.value, value: item.value },
                            item.label
                        );
                    })
                );
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(AbstractPicker, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                children = _props.children,
                _props$value = _props.value,
                value = _props$value === undefined ? [] : _props$value,
                extra = _props.extra,
                okText = _props.okText,
                itemStyle = _props.itemStyle,
                dismissText = _props.dismissText,
                popupPrefixCls = _props.popupPrefixCls,
                cascade = _props.cascade,
                prefixCls = _props.prefixCls,
                pickerPrefixCls = _props.pickerPrefixCls,
                data = _props.data,
                cols = _props.cols,
                onPickerChange = _props.onPickerChange,
                restProps = _objectWithoutProperties(_props, ['children', 'value', 'extra', 'okText', 'itemStyle', 'dismissText', 'popupPrefixCls', 'cascade', 'prefixCls', 'pickerPrefixCls', 'data', 'cols', 'onPickerChange']);

            var cascader = void 0;
            var popupMoreProps = {};
            if (cascade) {
                cascader = _react2.default.createElement(_Cascader2.default, {
                    prefixCls: prefixCls,
                    pickerPrefixCls: pickerPrefixCls,
                    data: data,
                    cols: cols,
                    onChange: onPickerChange,
                    pickerItemStyle: itemStyle
                });
            } else {
                cascader = _react2.default.createElement(
                    _MultiPicker2.default,
                    {
                        prefixCls: prefixCls,
                        pickerItemStyle: itemStyle
                    },
                    this.getPickerCol()
                );
                popupMoreProps = {
                    pickerValueProp: 'selectedValue',
                    pickerValueChangeProp: 'onValueChange'
                };
            }
            return _react2.default.createElement(
                _Popup2.default,
                _extends({
                    cascader: cascader
                }, this.popupProps, restProps, {
                    prefixCls: popupPrefixCls,
                    value: value,
                    dismissText: dismissText,
                    okText: okText
                }, popupMoreProps),
                _react2.default.cloneElement(children, { extra: this.getSel() || extra })
            );
        }
    }]);

    return AbstractPicker;
}(_react2.default.Component);

exports.default = AbstractPicker;