'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _List = require('../List');

var _List2 = _interopRequireDefault(_List);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _omit = require('omit.js');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListItem = _List2.default.Item;

function noop() {}

var RadioItem = (_temp = _class = function (_Component) {
  _inherits(RadioItem, _Component);

  function RadioItem() {
    _classCallCheck(this, RadioItem);

    return _possibleConstructorReturn(this, (RadioItem.__proto__ || Object.getPrototypeOf(RadioItem)).apply(this, arguments));
  }

  _createClass(RadioItem, [{
    key: 'render',
    value: function render() {
      var _classNames,
          _this2 = this;

      var _props = this.props,
          prefixCls = _props.prefixCls,
          listPrefixCls = _props.listPrefixCls,
          className = _props.className,
          children = _props.children,
          disabled = _props.disabled,
          _props$radioProps = _props.radioProps,
          radioProps = _props$radioProps === undefined ? {} : _props$radioProps;


      var wrapCls = (0, _classnames2.default)((_classNames = {}, _defineProperty(_classNames, prefixCls + '-item', true), _defineProperty(_classNames, prefixCls + '-item-disabled', disabled === true), _defineProperty(_classNames, className, !!className), _classNames));

      // Note: if not omit `onChange`, it will trigger twice on check listitem
      var otherProps = (0, _omit2.default)(this.props, ['listPrefixCls', 'onChange', 'disabled', 'radioProps']);

      if (disabled) {
        delete otherProps.onClick;
      } else {
        otherProps.onClick = otherProps.onClick || noop;
      }

      var extraProps = {};
      ['name', 'defaultChecked', 'checked', 'onChange', 'disabled'].forEach(function (i) {
        if (i in _this2.props) {
          extraProps[i] = _this2.props[i];
        }
      });

      return _react2.default.createElement(
        ListItem,
        _extends({}, otherProps, {
          prefixCls: listPrefixCls,
          className: wrapCls,
          extra: _react2.default.createElement(_index2.default, _extends({}, radioProps, extraProps))
        }),
        children
      );
    }
  }]);

  return RadioItem;
}(_react.Component), _class.defaultProps = {
  prefixCls: 'radio',
  listPrefixCls: 'list'
}, _temp);
exports.default = RadioItem;