"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp, _initialiseProps;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _classnames5 = require("classnames");

var _classnames6 = _interopRequireDefault(_classnames5);

var _getDataAttr = require("../_util/getDataAttr");

var _getDataAttr2 = _interopRequireDefault(_getDataAttr);

var _rmcFeedback = require("rmc-feedback");

var _rmcFeedback2 = _interopRequireDefault(_rmcFeedback);

var _AppIcon = require("../AppIcon");

var _AppIcon2 = _interopRequireDefault(_AppIcon);

require("./style/index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SearchBar = (_temp = _class = function (_Component) {
  _inherits(SearchBar, _Component);

  function SearchBar(props) {
    _classCallCheck(this, SearchBar);

    var _this = _possibleConstructorReturn(this, (SearchBar.__proto__ || Object.getPrototypeOf(SearchBar)).call(this, props));

    _initialiseProps.call(_this);

    var value = void 0;
    if ("value" in props) {
      value = props.value || "";
    } else if ("defaultValue" in props) {
      value = props.defaultValue;
    } else {
      value = "";
    }

    _this.state = {
      value: value,
      focus: false
    };
    return _this;
  }

  _createClass(SearchBar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var initBtn = window.getComputedStyle(this.rightBtnRef);
      this.rightBtnInitMarginleft = initBtn["margin-left"];
      this.componentDidUpdate();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      // 检测是否包含名为 ${this.props.prefixCls}-start 样式，生成动画
      // offsetWidth 某些时候是向上取整，某些时候是向下取整，不能用
      var realWidth = this.syntheticPhContainerRef.getBoundingClientRect().width; // 包含小数
      if (this.inputContainerRef.className.indexOf(this.props.prefixCls + "-start") > -1) {
        this.syntheticPhRef.style.width = Math.ceil(realWidth) + "px";
        if (!this.props.showCancelButton) {
          this.rightBtnRef.style.marginRight = 0;
        }
      } else {
        this.syntheticPhRef.style.width = '100%';
        if (!this.props.showCancelButton) {
          this.rightBtnRef.style.marginRight = "-" + (this.rightBtnRef.offsetWidth + parseInt(this.rightBtnInitMarginleft, 10)) + "px";
        }
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if ("value" in nextProps && nextProps.value !== this.state.value) {
        this.setState({
          value: nextProps.value
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.scrollIntoViewTimeout) {
        clearTimeout(this.scrollIntoViewTimeout);
        this.scrollIntoViewTimeout = null;
      }
      if (this.onBlurTimeout) {
        clearTimeout(this.onBlurTimeout);
        this.onBlurTimeout = null;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames3,
          _classnames4,
          _this2 = this;

      var _props = this.props,
          prefixCls = _props.prefixCls,
          showCancelButton = _props.showCancelButton,
          showScanCode = _props.showScanCode,
          disabled = _props.disabled,
          placeholder = _props.placeholder,
          className = _props.className,
          style = _props.style,
          maxLength = _props.maxLength,
          cancelText = _props.cancelText;
      var _state = this.state,
          value = _state.value,
          focus = _state.focus;


      var wrapCls = (0, _classnames6.default)(prefixCls, className, _defineProperty({}, prefixCls + "-start", !!(focus || value && value.length > 0)));

      var clearCls = (0, _classnames6.default)(prefixCls + "-clear", _defineProperty({}, prefixCls + "-clear-show", !!(focus && value && value.length > 0)));

      var cancelCls = (0, _classnames6.default)(prefixCls + "-cancel", (_classnames3 = {}, _defineProperty(_classnames3, prefixCls + "-cancel-show", showCancelButton || focus || value && value.length > 0), _defineProperty(_classnames3, prefixCls + "-cancel-anim", this.firstFocus), _classnames3));

      var scanCodeCls = (0, _classnames6.default)((_classnames4 = {}, _defineProperty(_classnames4, prefixCls + "-scan-code", showScanCode), _defineProperty(_classnames4, prefixCls + "-scan-code-and-cancel", showScanCode && showCancelButton), _classnames4));

      return _react2.default.createElement(
        "form",
        {
          onSubmit: this.onSubmit,
          className: wrapCls,
          style: style,
          ref: function ref(el) {
            return _this2.inputContainerRef = el;
          },
          action: "#"
        },
        _react2.default.createElement(
          "div",
          { className: prefixCls + "-input" },
          _react2.default.createElement(
            "div",
            {
              className: prefixCls + "-synthetic-ph",
              ref: function ref(el) {
                return _this2.syntheticPhRef = el;
              }
            },
            _react2.default.createElement(
              "span",
              {
                className: prefixCls + "-synthetic-ph-container",
                ref: function ref(el) {
                  return _this2.syntheticPhContainerRef = el;
                }
              },
              _react2.default.createElement("i", { className: prefixCls + "-synthetic-ph-icon" }),
              _react2.default.createElement(
                "span",
                {
                  className: prefixCls + "-synthetic-ph-placeholder",
                  style: {
                    visibility: placeholder && !value ? "visible" : "hidden"
                  }
                },
                placeholder
              )
            )
          ),
          _react2.default.createElement("input", _extends({
            type: "search",
            className: prefixCls + "-value",
            value: value,
            disabled: disabled,
            placeholder: placeholder,
            onChange: this.onChange,
            onFocus: this.onFocus,
            onBlur: this.onBlur,
            ref: function ref(el) {
              return _this2.inputRef = el;
            },
            maxLength: maxLength
          }, (0, _getDataAttr2.default)(this.props))),
          showScanCode ? _react2.default.createElement(
            _rmcFeedback2.default,
            null,
            _react2.default.createElement(
              "a",
              { onClick: this.onScanCode, className: scanCodeCls },
              _react2.default.createElement(_AppIcon2.default, { type: "saoma" })
            )
          ) : null,
          _react2.default.createElement(
            _rmcFeedback2.default,
            { activeClassName: prefixCls + "-clear-active" },
            _react2.default.createElement(
              "a",
              { onClick: this.onClear, className: clearCls },
              _react2.default.createElement(_AppIcon2.default, { type: "guanbi1" })
            )
          )
        ),
        _react2.default.createElement(
          "div",
          {
            className: cancelCls,
            onClick: this.onCancel,
            ref: function ref(el) {
              return _this2.rightBtnRef = el;
            }
          },
          cancelText
        )
      );
    }
  }]);

  return SearchBar;
}(_react.Component), _class.defaultProps = {
  prefixCls: "search-bar",
  placeholder: "",
  onSubmit: function onSubmit() {},
  onChange: function onChange() {},
  onFocus: function onFocus() {},
  onBlur: function onBlur() {},
  onClear: function onClear() {},
  onScanCode: function onScanCode() {},
  showCancelButton: false,
  cancelText: "取消",
  disabled: false,
  showScanCode: false,
  autoFocus: false
}, _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.onSubmit = function (e) {
    e.preventDefault();

    if (_this3.props.onSubmit) {
      _this3.props.onSubmit(_this3.state.value);
    }

    _this3.inputRef.blur();
  };

  this.onChange = function (e) {
    if (!_this3.state.focus) {
      _this3.setState({
        focus: true
      });
    }
    var value = e.target.value;
    if (!("value" in _this3.props)) {
      _this3.setState({ value: value });
    }
    if (_this3.props.onChange) {
      _this3.props.onChange(value);
    }
  };

  this.onScanCode = function () {
    var returnValue = void 0;

    if (_this3.props.onScanCode) {
      returnValue = _this3.props.onScanCode() || "";

      if (returnValue == "") {
        _this3.setState({ value: value });
      } else {
        _this3.setState({ value: returnValue });
      }

      //this.refs.searchInput.blur();
    }
  };

  this.onFocus = function () {
    _this3.setState({
      focus: true
    });
    _this3.firstFocus = true;

    if (_this3.props.onFocus) {
      _this3.props.onFocus();
    }

    if (_this3.props.onFocus) {
      _this3.props.onFocus();
    }

    if (document.activeElement.tagName.toLowerCase() === "input") {
      _this3.scrollIntoViewTimeout = setTimeout(function () {
        try {
          document.activeElement.scrollIntoViewIfNeeded();
        } catch (e) {}
      }, 100);
    }
  };

  this.onBlur = function () {
    _this3.onBlurTimeout = setTimeout(function () {
      if (!_this3.blurFromOnClear) {
        if (document.activeElement !== _this3.inputRef) {
          _this3.setState({
            focus: false
          });
        }
      }
      _this3.blurFromOnClear = false;
    }, 50);

    if (_this3.props.onBlur) {
      _this3.props.onBlur();
    }
  };

  this.onClear = function () {
    _this3.doClear();
  };

  this.doClear = function () {
    var blurFromOnClear = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

    _this3.blurFromOnClear = blurFromOnClear;

    if (!('value' in _this3.props)) {
      _this3.setState({ value: "" });
    }
    if (_this3.props.onClear) {
      _this3.props.onClear("");
    }
    if (_this3.props.onChange) {
      _this3.props.onChange("");
    }
    if (blurFromOnClear) {
      _this3.focus();
    }
  };

  this.onCancel = function () {
    if (_this3.props.onCancel) {
      _this3.props.onCancel(_this3.state.value);
    } else {
      _this3.doClear(false);
    }
  };

  this.focus = function () {
    _this3.inputRef.focus();
  };
}, _temp);
exports.default = SearchBar;