'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcSteps = require('rc-steps');

var _rcSteps2 = _interopRequireDefault(_rcSteps);

var _AppIcon = require('../AppIcon');

var _AppIcon2 = _interopRequireDefault(_AppIcon);

require('./style/index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Steps = (_temp = _class = function (_React$Component) {
  _inherits(Steps, _React$Component);

  function Steps() {
    _classCallCheck(this, Steps);

    return _possibleConstructorReturn(this, (Steps.__proto__ || Object.getPrototypeOf(Steps)).apply(this, arguments));
  }

  _createClass(Steps, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.componentDidUpdate();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.props.direction !== 'horizontal') {
        return;
      }
      //set tail's left position based on main's width for each step dynamically.
      this.stepRefs.forEach(function (s) {
        if (s.refs.tail) {
          s.refs.tail.style.left = s.refs.main.offsetWidth / 2 + 'px';
        }
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      this.stepRefs = [];
      var _props = this.props,
          children = _props.children,
          status = _props.status;

      var current = this.props.current;
      //flattern the array at first https://github.com/ant-design/ant-design-mobile/issues/934
      var newChildren = _react2.default.Children.map(children, function (item) {
        return item;
      });
      newChildren = _react2.default.Children.map(newChildren, function (item, index) {
        var className = item.props.className;
        if (index < newChildren.length - 1 && newChildren[index + 1].props.status === 'error') {
          className = className ? className + ' error-tail' : 'error-tail';
        }

        var icon = item.props.icon;
        if (!icon) {
          if (index < current) {
            // 对应 state: finish
            icon = 'gou';
          } else if (index > current) {
            // 对应 state: wait
            icon = 'msnui-more-copy';
            className = className ? className + ' ellipsis-item' : 'ellipsis-item';
          }
          if (status === 'error' && index === current || item.props.status === 'error') {
            icon = 'gou';
          }
        }
        icon = typeof icon === 'string' ? _react2.default.createElement(_AppIcon2.default, { type: icon }) : icon;
        return _react2.default.cloneElement(item, { icon: icon, className: className, ref: function ref(c) {
            return _this2.stepRefs[index] = c;
          } });
      });
      return _react2.default.createElement(
        _rcSteps2.default,
        _extends({ ref: function ref(el) {
            return _this2.stepsRef = el;
          } }, this.props),
        newChildren
      );
    }
  }]);

  return Steps;
}(_react2.default.Component), _class.Step = _rcSteps2.default.Step, _class.defaultProps = {
  prefixCls: 'steps',
  iconPrefix: '',
  labelPlacement: 'vertical',
  direction: 'vertical',
  current: 0
}, _temp);
exports.default = Steps;