'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = exports.Item = undefined;

var _class, _temp2;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcTabs = require('rc-tabs');

var _rcTabs2 = _interopRequireDefault(_rcTabs);

var _Tab = require('./Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _TabContent = require('rc-tabs/lib/TabContent');

var _TabContent2 = _interopRequireDefault(_TabContent);

var _TabBar = require('rc-tabs/lib/TabBar');

var _TabBar2 = _interopRequireDefault(_TabBar);

var _getDataAttr = require('../_util/getDataAttr');

var _getDataAttr2 = _interopRequireDefault(_getDataAttr);

require('./style/index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Item = exports.Item = function (_React$Component) {
    _inherits(Item, _React$Component);

    function Item() {
        _classCallCheck(this, Item);

        return _possibleConstructorReturn(this, (Item.__proto__ || Object.getPrototypeOf(Item)).apply(this, arguments));
    }

    _createClass(Item, [{
        key: 'render',
        value: function render() {
            return null;
        }
    }]);

    return Item;
}(_react2.default.Component);

;

var TabsBar = (_temp2 = _class = function (_React$Component2) {
    _inherits(TabsBar, _React$Component2);

    function TabsBar() {
        var _ref;

        var _temp, _this2, _ret;

        _classCallCheck(this, TabsBar);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this2 = _possibleConstructorReturn(this, (_ref = TabsBar.__proto__ || Object.getPrototypeOf(TabsBar)).call.apply(_ref, [this].concat(args))), _this2), _this2.onChange = function (key) {
            _react2.default.Children.forEach(_this2.props.children, function (c) {
                if (c.key === key && c.props.onPress) {
                    c.props.onPress();
                }
            });
        }, _this2.renderTabBar = function () {
            var _this2$props = _this2.props,
                barTintColor = _this2$props.barTintColor,
                hidden = _this2$props.hidden,
                prefixCls = _this2$props.prefixCls;

            var barCls = hidden ? prefixCls + '-bar-hidden' : '';
            return _react2.default.createElement(_TabBar2.default, { className: barCls, style: { backgroundColor: barTintColor } });
        }, _this2.renderTabContent = function () {
            return _react2.default.createElement(_TabContent2.default, { animated: false });
        }, _temp), _possibleConstructorReturn(_this2, _ret);
    }

    _createClass(TabsBar, [{
        key: 'render',
        value: function render() {
            var _this3 = this;

            var activeKey = void 0;
            var children = [];
            var _allKeys = [];
            _react2.default.Children.forEach(this.props.children, function (c) {

                if (c.props.selected) {
                    activeKey = c.key;
                }
                children.push(c);
            });
            var _props = this.props,
                tintColor = _props.tintColor,
                unselectedTintColor = _props.unselectedTintColor,
                className = _props.className;

            var panels = children.map(function (c) {
                var cProps = c.props;
                var tab = _react2.default.createElement(_Tab2.default, {
                    prefixCls: _this3.props.prefixCls + '-tab',
                    badge: cProps.badge,
                    useIcon: cProps.useIcon,
                    dot: cProps.dot,
                    selected: cProps.selected,
                    icon: cProps.icon,
                    selectedIcon: cProps.selectedIcon,
                    title: cProps.title,
                    tintColor: tintColor,
                    unselectedTintColor: unselectedTintColor,
                    dataAttrs: (0, _getDataAttr2.default)(cProps)
                });
                return _react2.default.createElement(
                    _rcTabs.TabPane,
                    {
                        placeholder: _this3.props.placeholder,
                        tab: tab,
                        key: c.key
                    },
                    cProps.children
                );
            });
            return _react2.default.createElement(
                _rcTabs2.default,
                {
                    renderTabBar: this.renderTabBar,
                    renderTabContent: this.renderTabContent,
                    tabBarPosition: 'bottom',
                    prefixCls: this.props.prefixCls,
                    activeKey: activeKey,
                    onChange: this.onChange,
                    className: className
                },
                panels
            );
        }
    }]);

    return TabsBar;
}(_react2.default.Component), _class.defaultProps = {
    prefixCls: 'tab-bar',
    barTintColor: 'white',
    tintColor: '#5491de',
    hidden: false,
    unselectedTintColor: '#999',
    placeholder: '正在加载'
}, _class.Item = Item, _temp2);
exports.default = TabsBar;
;