'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _rcTable = require('rc-table');

var _rcTable2 = _interopRequireDefault(_rcTable);

require('./style/index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Table = (_temp = _class = function (_Component) {
    _inherits(Table, _Component);

    function Table() {
        _classCallCheck(this, Table);

        return _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).apply(this, arguments));
    }

    _createClass(Table, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                prefixCls = _props.prefixCls,
                columns = _props.columns,
                dataSource = _props.dataSource,
                direction = _props.direction,
                scrollX = _props.scrollX,
                titleFixed = _props.titleFixed,
                emptyText = _props.emptyText;


            var newProps = (0, _objectAssign2.default)({}, this.props, { data: dataSource });

            var table = void 0;
            //默认纵向
            if (!direction || direction === 'vertical') {
                if (titleFixed) {
                    table = _react2.default.createElement(_rcTable2.default, _extends({}, newProps, { columns: columns, scroll: { x: true }, showHeader: false }));
                } else {
                    table = _react2.default.createElement(_rcTable2.default, _extends({}, newProps, { columns: columns, scroll: { x: scrollX } }));
                }
                // 横向
            } else if (direction === 'horizon') {
                columns[0].className = prefixCls + '-horizonTitle';
                table = _react2.default.createElement(_rcTable2.default, _extends({}, newProps, { columns: columns, showHeader: false, scroll: { x: scrollX } }));
                // 混合
            } else if (direction === 'mix') {
                columns[0].className = prefixCls + '-horizonTitle';
                table = _react2.default.createElement(_rcTable2.default, _extends({}, newProps, { columns: columns, scroll: { x: scrollX } }));
            }

            return table;
        }
    }]);

    return Table;
}(_react.Component), _class.defaultProps = {
    dataSource: [],
    prefixCls: 'table',
    emptyText: function emptyText() {
        return '暂无数据';
    }
}, _temp);
exports.default = Table;