'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * Created by seven on 2017/2/22.
                                                                                                                                                                                                                                                                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcTabs = require('rc-tabs');

var _rcTabs2 = _interopRequireDefault(_rcTabs);

var _SwipeableTabContent = require('rc-tabs/lib/SwipeableTabContent');

var _SwipeableTabContent2 = _interopRequireDefault(_SwipeableTabContent);

var _TabContent = require('rc-tabs/lib/TabContent');

var _TabContent2 = _interopRequireDefault(_TabContent);

var _InkTabBar = require('rc-tabs/lib/InkTabBar');

var _InkTabBar2 = _interopRequireDefault(_InkTabBar);

var _SwipeableInkTabBar = require('rc-tabs/lib/SwipeableInkTabBar');

var _SwipeableInkTabBar2 = _interopRequireDefault(_SwipeableInkTabBar);

require('./style/index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Tabs = _react2.default.createClass({
  displayName: 'Tabs',

  statics: {
    TabPane: _rcTabs.TabPane
  },

  getDefaultProps: function getDefaultProps() {
    return {
      prefixCls: 'tabs',
      animated: true,
      swipeable: true,
      tabBarPosition: 'top',
      hammerOptions: {},
      tabBarhammerOptions: {},
      pageSize: 5,
      speed: 8,
      onChange: function onChange() {},
      onTabClick: function onTabClick() {}
    };
  },
  renderTabBar: function renderTabBar() {
    var _props = this.props,
        children = _props.children,
        animated = _props.animated,
        speed = _props.speed,
        pageSize = _props.pageSize,
        tabBarhammerOptions = _props.tabBarhammerOptions,
        onTabClick = _props.onTabClick;

    if (children.length > pageSize) {
      return _react2.default.createElement(_SwipeableInkTabBar2.default, {
        onTabClick: onTabClick,
        speed: speed,
        pageSize: pageSize,
        hammerOptions: tabBarhammerOptions
      });
    }
    return _react2.default.createElement(_InkTabBar2.default, { inkBarAnimated: animated });
  },
  renderTabContent: function renderTabContent() {
    var _props2 = this.props,
        animated = _props2.animated,
        swipeable = _props2.swipeable,
        hammerOptions = _props2.hammerOptions;

    return swipeable ? _react2.default.createElement(_SwipeableTabContent2.default, { animated: animated, hammerOptions: hammerOptions }) : _react2.default.createElement(_TabContent2.default, { animated: animated });
  },
  render: function render() {
    return _react2.default.createElement(_rcTabs2.default, _extends({
      renderTabBar: this.renderTabBar,
      renderTabContent: this.renderTabContent
    }, this.props));
  }
});

exports.default = Tabs;