'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _rmcFeedback = require('rmc-feedback');

var _rmcFeedback2 = _interopRequireDefault(_rmcFeedback);

require('./style/index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function noop() {}

function fixControlledValue(value) {
  if (typeof value === 'undefined' || value === null) {
    return '';
  }
  return value;
}

var regexAstralSymbols = /[\uD800-\uDBFF][\uDC00-\uDFFF]|\n/g;

function countSymbols() {
  var text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  return text.replace(regexAstralSymbols, '_').length;
}

var TextareaItem = (_temp = _class = function (_React$Component) {
  _inherits(TextareaItem, _React$Component);

  function TextareaItem(props) {
    _classCallCheck(this, TextareaItem);

    var _this = _possibleConstructorReturn(this, (TextareaItem.__proto__ || Object.getPrototypeOf(TextareaItem)).call(this, props));

    _this.focus = function () {
      _this.textareaRef.focus();
    };

    _this.onChange = function (e) {
      var value = e.target.value;
      var onChange = _this.props.onChange;

      if (onChange) {
        onChange(value);
      }
      //设置 defaultValue 时，用户输入不会触发 componentDidUpdate ， 此处手工调用
      _this.componentDidUpdate();
    };

    _this.onBlur = function (e) {
      _this.debounceTimeout = setTimeout(function () {
        _this.setState({
          focus: false
        });
      }, 100);
      _this.setState({
        focus: false
      });
      var value = e.target.value;
      if (_this.props.onBlur) {
        _this.props.onBlur(value);
      }
    };

    _this.onFocus = function (e) {
      if (_this.debounceTimeout) {
        clearTimeout(_this.debounceTimeout);
        _this.debounceTimeout = null;
      }
      _this.setState({
        focus: true
      });
      var value = e.target.value;
      if (_this.props.onFocus) {
        _this.props.onFocus(value);
      }

      if (document.activeElement.tagName.toLowerCase() === 'textarea') {
        _this.scrollIntoViewTimeout = setTimeout(function () {
          try {
            document.activeElement.scrollIntoViewIfNeeded();
          } catch (e) {}
        }, 100);
      }
    };

    _this.onErrorClick = function () {
      if (_this.props.onErrorClick) {
        _this.props.onErrorClick();
      }
    };

    _this.clearInput = function () {
      if (_this.props.onChange) {
        _this.props.onChange('');
      }
    };

    _this.state = {
      focus: false
    };
    return _this;
  }

  _createClass(TextareaItem, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.props.autoHeight) {
        var textareaDom = this.textareaRef;
        textareaDom.style.height = ''; //字数减少时能自动减少高度
        textareaDom.style.height = textareaDom.scrollHeight + 'px';
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.debounceTimeout) {
        clearTimeout(this.debounceTimeout);
        this.debounceTimeout = null;
      }

      if (this.scrollIntoViewTimeout) {
        clearTimeout(this.scrollIntoViewTimeout);
        this.scrollIntoViewTimeout = null;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _classNames,
          _classNames2,
          _this2 = this;

      var _props = this.props,
          prefixCls = _props.prefixCls,
          prefixListCls = _props.prefixListCls,
          editable = _props.editable,
          style = _props.style,
          clear = _props.clear,
          children = _props.children,
          error = _props.error,
          className = _props.className,
          count = _props.count,
          labelNumber = _props.labelNumber,
          title = _props.title,
          onErrorClick = _props.onErrorClick,
          autoHeight = _props.autoHeight,
          otherProps = _objectWithoutProperties(_props, ['prefixCls', 'prefixListCls', 'editable', 'style', 'clear', 'children', 'error', 'className', 'count', 'labelNumber', 'title', 'onErrorClick', 'autoHeight']);

      var value = otherProps.value,
          defaultValue = otherProps.defaultValue,
          disabled = otherProps.disabled;


      var valueProps = void 0;
      if ('value' in this.props) {
        valueProps = {
          value: fixControlledValue(value)
        };
      } else {
        valueProps = {
          defaultValue: defaultValue
        };
      }

      var focus = this.state.focus;


      var wrapCls = (0, _classnames2.default)(className, prefixListCls + '-item', prefixCls + '-item', (_classNames = {}, _defineProperty(_classNames, prefixCls + '-disabled', disabled), _defineProperty(_classNames, prefixCls + '-item-single-line', this.props.rows === 1 && !autoHeight), _defineProperty(_classNames, prefixCls + '-error', error), _defineProperty(_classNames, prefixCls + '-focus', focus), _classNames));

      var labelCls = (0, _classnames2.default)(prefixCls + '-label', (_classNames2 = {}, _defineProperty(_classNames2, prefixCls + '-label-2', labelNumber === 2), _defineProperty(_classNames2, prefixCls + '-label-3', labelNumber === 3), _defineProperty(_classNames2, prefixCls + '-label-4', labelNumber === 4), _defineProperty(_classNames2, prefixCls + '-label-5', labelNumber === 5), _defineProperty(_classNames2, prefixCls + '-label-6', labelNumber === 6), _defineProperty(_classNames2, prefixCls + '-label-7', labelNumber === 7), _classNames2));
      var characterLength = countSymbols(value);
      var lengthCtrlProps = {};

      if (count > 0) {
        lengthCtrlProps.maxLength = count - characterLength + (value ? value.length : 0);
      }

      return _react2.default.createElement(
        'div',
        { className: wrapCls },
        title && _react2.default.createElement(
          'div',
          { className: labelCls },
          title
        ),
        _react2.default.createElement(
          'div',
          { className: prefixCls + '-control' },
          _react2.default.createElement('textarea', _extends({
            ref: function ref(el) {
              return _this2.textareaRef = el;
            }
          }, lengthCtrlProps, otherProps, valueProps, {
            onChange: this.onChange,
            onBlur: this.onBlur,
            onFocus: this.onFocus,
            readOnly: !editable,
            style: style
          }))
        ),
        clear && editable && value && characterLength > 0 && _react2.default.createElement(
          _rmcFeedback2.default,
          { activeClassName: prefixCls + '-clear-active' },
          _react2.default.createElement('div', { className: prefixCls + '-clear', onClick: this.clearInput, onTouchStart: this.clearInput })
        ),
        error && _react2.default.createElement('div', { className: prefixCls + '-error-extra', onClick: this.onErrorClick }),
        count > 0 && this.props.rows > 1 && _react2.default.createElement(
          'span',
          { className: prefixCls + '-count' },
          _react2.default.createElement(
            'span',
            null,
            value ? characterLength : 0
          ),
          '/',
          count
        )
      );
    }
  }]);

  return TextareaItem;
}(_react2.default.Component), _class.defaultProps = {
  prefixCls: 'textarea',
  prefixListCls: 'list',
  autoHeight: false,
  editable: true,
  disabled: false,
  placeholder: '',
  clear: false,
  rows: 1,
  onChange: noop,
  onBlur: noop,
  onFocus: noop,
  onErrorClick: noop,
  error: false,
  labelNumber: 5
}, _temp);
exports.default = TextareaItem;